/*
 *	main.c
 *
 *	RYMOǂ
 *
 *	* Wed Jul 28 21:41:00 JST 2004 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo_main() < 0) break;
		schedule(); /* gKNÂ */
		game_main();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef TEXTURE_LIST
	{
		typedef const unsigned char TEXTURE_DATA[];
		extern TEXTURE_DATA TEXTURE_LIST;
		texture_table_init(texture_table, sizeof texture_table / sizeof *texture_table, TEXTURE_LIST);
	}
#endif /*TEXTURE_LIST*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());

	/* ̂߁AwiC[WWJĂ܂B */
	sprite_draw(0, 0, SPR_BG, 0);
	memcpy(bgbuff, vbuff, DISP_X * DISP_Y);
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
//#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x5f0		/* PAUSEJ[(16KEwip) */
#define PAUSE_COLOR	0xa0f		/* PAUSEJ[(16KEwip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	
 ****************************************************************************/

//                                       Q~      ~P      PO       OQ       ~~
//                                       OP      QO      ~Q       P~       O~
const int block_col_ofs[/*rot*/][3] = { {0,1, 0}, {1, 1,0}, { 1, 0,1}, { 0,0, 1}, {0,0,0} };
const int block_row_ofs[/*rot*/][3] = { {0,0,-1}, {0,-1,0}, {-1,-1,0}, {-1,0,-1}, {0,0,0} };

const int PAT_COSMO_R[] = { /* E] */
	SPR_CSM000,SPR_CSM000,SPR_CSM000,SPR_CSM000,SPR_CSM000,SPR_CSM000,
	SPR_CSM001,SPR_CSM001,SPR_CSM001,SPR_CSM001,SPR_CSM001,SPR_CSM001,
	SPR_CSM002,SPR_CSM002,SPR_CSM002,SPR_CSM002,SPR_CSM002,SPR_CSM002,
	SPR_CSM003,SPR_CSM003,SPR_CSM003,SPR_CSM003,SPR_CSM003,SPR_CSM003,
};
/* 90,180,270x]́AXvCgԍ4~NZĂB */

const int PAT_COSMO_S[] = { /* RYEX^[ */
	SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,
	SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,
	SPR_CSM700,SPR_CSM700,
	SPR_CSM701,SPR_CSM701,
	SPR_CSM702,SPR_CSM702,
	SPR_CSM703,SPR_CSM703,
};

const int PAT_COSMO_0[] = { /* ʏ */
	SPR_CSM100,SPR_CSM100,SPR_CSM100,SPR_CSM100,SPR_CSM100,SPR_CSM100,
	SPR_CSM101,SPR_CSM101,SPR_CSM101,SPR_CSM101,SPR_CSM101,SPR_CSM101,
	SPR_CSM100,SPR_CSM100,SPR_CSM100,SPR_CSM100,SPR_CSM100,SPR_CSM100,
	SPR_CSM102,SPR_CSM102,SPR_CSM102,SPR_CSM102,SPR_CSM102,SPR_CSM102,
	SPR_CSM100,SPR_CSM100,SPR_CSM100,SPR_CSM100,SPR_CSM100,SPR_CSM100,
	SPR_CSM103,SPR_CSM103,SPR_CSM103,SPR_CSM103,SPR_CSM103,SPR_CSM103,
	SPR_CSM100,SPR_CSM100,SPR_CSM100,SPR_CSM100,SPR_CSM100,SPR_CSM100,
	SPR_CSM104,SPR_CSM104,SPR_CSM104,SPR_CSM104,SPR_CSM104,SPR_CSM104,
};
const int PAT_COSMO_1[] = { /* Jn */
	SPR_CSM200,SPR_CSM200,SPR_CSM200,SPR_CSM200,
	SPR_CSM201,SPR_CSM201,SPR_CSM201,SPR_CSM201,
	SPR_CSM202,SPR_CSM202,SPR_CSM202,SPR_CSM202,
	SPR_CSM203,SPR_CSM203,SPR_CSM203,SPR_CSM203,SPR_CSM203,SPR_CSM203,SPR_CSM203,SPR_CSM203,
	SPR_CSM202,SPR_CSM202,SPR_CSM202,SPR_CSM202,
	SPR_CSM201,SPR_CSM201,SPR_CSM201,SPR_CSM201,
	SPR_CSM200,SPR_CSM200,SPR_CSM200,SPR_CSM200,
};
const int PAT_COSMO_2[] = { /*  */
	SPR_CSM204,SPR_CSM204,SPR_CSM204,SPR_CSM204,SPR_CSM204,SPR_CSM204,SPR_CSM204,SPR_CSM204,
	SPR_CSM205,SPR_CSM205,SPR_CSM205,SPR_CSM205,
	SPR_CSM206,SPR_CSM206,SPR_CSM206,SPR_CSM206,
	SPR_CSM207,SPR_CSM207,SPR_CSM207,SPR_CSM207,
	SPR_CSM208,SPR_CSM208,SPR_CSM208,SPR_CSM208,
	SPR_CSM209,SPR_CSM209,SPR_CSM209,SPR_CSM209,SPR_CSM209,SPR_CSM209,SPR_CSM209,SPR_CSM209,
	SPR_CSM208,SPR_CSM208,SPR_CSM208,SPR_CSM208,
	SPR_CSM207,SPR_CSM207,SPR_CSM207,SPR_CSM207,
	SPR_CSM206,SPR_CSM206,SPR_CSM206,SPR_CSM206,
	SPR_CSM205,SPR_CSM205,SPR_CSM205,SPR_CSM205,
};
const int PAT_COSMO_3[] = { /* N#1 */
	SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,
	SPR_CSM302,SPR_CSM302,SPR_CSM302,SPR_CSM302,
	SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,
	SPR_CSM303,SPR_CSM303,SPR_CSM303,SPR_CSM303,
	SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,
	SPR_CSM304,SPR_CSM304,SPR_CSM304,SPR_CSM304,SPR_CSM304,SPR_CSM304,SPR_CSM304,SPR_CSM304,
};
const int PAT_COSMO_4[] = { /* N#2 */
	SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,
	SPR_CSM400,SPR_CSM400,SPR_CSM400,SPR_CSM400,
	SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,
	SPR_CSM401,SPR_CSM401,SPR_CSM401,SPR_CSM401,
	SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,SPR_CSM301,
};
const int PAT_COSMO_5[] = { /* #1 */
	SPR_CSM300,SPR_CSM300,
	SPR_CSM301,SPR_CSM301,
	SPR_CSM300,SPR_CSM300,
	SPR_CSM301,SPR_CSM301,
	SPR_CSM300,SPR_CSM300,
};
#define PAT_COSMO_6 PAT_COSMO_3 /* #2 */
const int PAT_COSMO_7[] = { /* Q[I[o[ */
	SPR_CSM600,SPR_CSM600,SPR_CSM600,SPR_CSM600,
	SPR_CSM601,SPR_CSM601,SPR_CSM601,SPR_CSM601,
};

/****************************************************************************
 *	demo_main
 ****************************************************************************/

int
demo_main()
{
	int result = -1;
	int x;
	int y;

	for(;;) {
		schedule();

		/* ^Cg\B */
		sprite_draw(0, 0, SPR_TITLE, 0);

		/* X^[gHIH */
		if(joy & TRG_A) {
			result = 0;
			break;
		}
		if(joy & TRG_SELECT) {
			result = -1;
			break;
		}

		/* ՓxIB */
		if((joy & TRG_LF) && (level_sel > 0)) {
			level_sel--;
		}
		if((joy & TRG_RI) && (level_sel < 3)) {
			level_sel++;
		}

		/* XRA\B */
		x = 1;
		y = 1;
		render_string_framed(&render, x, y, "HISCORE", 0x82, 0xa3f);
		y += 8;
		render_printf_framed(&render, x, y, 0x82, 0xa5f, "%7d", hiscore <= 9999999 ? hiscore : 9999999);
		x = DISP_X - 4 * 7 - 2;
		y = 1;
		render_string_framed(&render, x, y, "  SCORE", 0x82, 0xa3f);
		y += 8;
		render_printf_framed(&render, x, y, 0x82, 0xa5f, "%7d", game.score <= 9999999 ? game.score : 9999999);

		/* vvg\B */
		x = (DISP_X - 4 * 8) / 2;
		y = DISP_Y - 40;
		render_string_framed(&render, x, y, " A START", 0x82, 0xa3f);
		y += 8;
		render_string_framed(&render, x, y, "SEL EXIT", 0x82, 0xa3f);

		/* Փx\B */
		x = (DISP_X - 4 * 10) / 2;
		y = DISP_Y - 12;
		switch(level_sel) {
		case 0:
			render_string_framed(&render, x, y, "   EASY  >", 0x82, 0xa5f);
			break;
		case 1:
			render_string_framed(&render, x, y, "< NORMAL >", 0x82, 0xa5f);
			break;
		case 2:
			render_string_framed(&render, x, y, "<  HARD  >", 0x82, 0xa5f);
			break;
		case 3:
			render_string_framed(&render, x, y, "< EXPART  ", 0x82, 0xa5f);
			break;
		default:
			DIE();
		}
	}

	return result;
}

/****************************************************************************
 *	game_init
 ****************************************************************************/

void
game_init()
{
	/* ܂NAB */
	memset(&game, 0, sizeof game);

	/* V[hB */
	game.seed = now;

	/* xݒB */
	switch(level_sel) {
	case 0: game.level =   0; break;
	case 1: game.level =  10; break;
	case 2: game.level =  40; break;
	case 3: game.level = 100; break;
	default: DIE();
	}

	/* Q[Jn`ŏ̃ubNo܂łNEXT\̐̂߂ɁA
	 * ubN==NEXTƂĂ܂B
	 */
	block_gen();
	memcpy(game.block, game.next, sizeof(CELL) * 3);
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

void
game_main()
{
	int i;

	game_init();

	for(i = 0; i < SEC(1/**/); i++) {
		field_action();
		field_disp();
		render_string_framed(&render, FIELD_X + 1, FIELD_Y + CELL_H * 6 - 1, "r@@@@@", 0x80, 0xa0d);
		render_string_framed(&render, FIELD_X - 1, FIELD_Y + CELL_H * 6 - 1, "@s@@@@", 0x80, 0xa0d);
		render_string_framed(&render, FIELD_X - 3, FIELD_Y + CELL_H * 6 - 1, "@@`@@@", 0x80, 0xa0d);
		render_string_framed(&render, FIELD_X - 5, FIELD_Y + CELL_H * 6 - 1, "@@@q@@", 0x80, 0xa0d);
		render_string_framed(&render, FIELD_X - 7, FIELD_Y + CELL_H * 6 - 1, "@@@@s@", 0x80, 0xa0d);
		render_string_framed(&render, FIELD_X - 7, FIELD_Y + CELL_H * 6 - 1, "@@@@@! ", 0x80, 0xa0d);
		render_string_framed(&render, FIELD_X - 9, FIELD_Y + CELL_H * 6 - 1, "@@@@@ !", 0x80, 0xa0d);
		schedule();
	}

L_BLOCK:
	/*** ubN ***/

	game.combo = 0; /* AJEgNA */

	/* ubNoOfBCB */
	for(i = 0; i < SEC(0.25/**/); i++) {
		field_action();
		field_disp();
		schedule();
	}

	/* ubNB */
	block_gen();

	/* ubNʒuB
	 * ubNo\ȈʒuȂ΁AQ[I[o[B
	 */
	if(!block_init()) {
		goto L_GAMEOVER;
	}

	for(;;) {
		field_action();
		if(block_action()) {
			if(block_realize()) {
				goto L_STAR;
			}
			goto L_FALL;
		}
		field_disp();
		block_disp();
		schedule();
	}

L_STAR:
	/*** X^[ ***/
	for(;;) {
		field_action();
		if(!star_action()) { /* X^[ʊ */
			goto L_FALL;
		}
		field_disp();
		star_disp();
		schedule();
	}

	goto L_FALL;

L_FALL:
	/*** R ***/
	for(;;) {
		field_action();
		if(!fall_action()) { /* R */
			goto L_LINE;
		}
		field_disp();
		schedule();
	}

L_LINE:
	/*** Rei ***/

	/* ReiŌoAŏԏB
	 * łReiȂ΁ARYŏցB
	 */
	if(!line_test()) {
		goto L_BALL;
	}

	game.combo++; /* ŘAJEgAbv!! */

	for(;;) {
		field_action();
		if(!line_action()) { /* ReiŊ */
			break;
		}
		field_disp();
		schedule();
	}

	/* ReiŌfBCB */
	for(i = 0; i < SEC(0.25/**/); i++) {
		field_action();
		field_disp();
		schedule();
	}

	/* RցB
	 * ReiṒAڂɃRYŏֈڍŝł͂ȂAɎR֖߂!!
	 */
	goto L_FALL;

L_BALL:
	/*** RY ***/

	/* ̉{[̈ʒuB
	 * ̉{[Ȃ΁ÃubNoցB
	 */
	if(!ball_test()) {
		goto L_BLOCK;
	}

	for(;;) {
		field_action();
		if(!ball_action()) { /* {[ړ */
			break;
		}
		field_disp();
		ball_disp();
		schedule();
	}

	/* RYŌfBCB */
	for(i = 0; i < SEC(0.25/**/); i++) {
		field_action();
		field_disp();
		schedule();
	}

	/* ǎRցB */
	goto L_FALL;

L_GAMEOVER:
	/*** Q[I[o[ ***/

	for(i = 0; i < SEC(10/**/); i++) {
		field_action();
		if(joy & TRG_AB) {
			break;
		}
		field_disp();
		if(gameover_action(i)) {
			render_string_framed(&render, FIELD_X + 7, FIELD_Y + CELL_H * 6 - 1, "f`ld", 0x80, 0xa3f);
			render_string_framed(&render, FIELD_X + 7, FIELD_Y + CELL_H * 7 + 3, "nudq", 0x80, 0xa3f);
		}
		schedule();
	}

	/* nCXRAXVB */
	if(game.score > hiscore) {
		hiscore = game.score;
	}
}

/****************************************************************************
 *	block_gen
 ****************************************************************************/

void
block_gen()
{
	int i;
	CELL* cell;

	memcpy(game.block, game.next, sizeof(CELL) * 3);
	memset(game.next, 0, sizeof(CELL) * 3);

	/* RYSTAR_FULL(=100)CȏxɃX^[oBX^[͏ɒPƂłB */
	if(game.star >= STAR_FULL) {
		game.star -= STAR_FULL;
		cell = &game.next[0];
		cell->type = CELL_STAR;
		return;
	}

	/* AEÃubNZ쐬B */
	for(i = 0; i < 3; i++) {
		cell = &game.next[i];
		cell->type = (RND16(game.seed) & 255) < 128/*v*/ ? CELL_COSMO : CELL_CONTAINER;
	}

	/* ubNoH񖈂ɁAubNɃ{[B */
	game.block_cnt++;
	if(game.block_cnt >= BALL_INTERVAL) {
		if(game.level < 2) { /* LEVEL2́APƃ{[ */
			i = 0;
			memset(game.next, 0, sizeof(CELL) * 3);
		} else {
			i = RND16(game.seed) % 3;
			memset(&game.next[i], 0, sizeof(CELL));
		}
		cell = &game.next[i];
		cell->type = CELL_BALL;
		cell->stat = (RND16(game.seed) & 255) < 128 ? 0/*E*/ : 1/**/;
		game.block_cnt = 0;
	}
}

/****************************************************************************
 *	block_init
 ****************************************************************************/

int
block_init()
{
	static const int cols[3][6 + 1] = {
		{ 2,3,1,4,0,5,-1 }, /* 0:Neutral */
		{ 2,3,4,5,1,0,-1 }, /* 1:PAD_RI  */
		{ 2,1,0,3,4,5,-1 }, /* 2:PAD_LF  */
	};
	int result;
	const int* p;
	int col;

	/* Zg\NAB */
	border_clr();

	/* X^[LZB */
	game.star_cancel = 0;

	/* xAbvB */
	game.level_cnt++;
	if(game.level_cnt == 10) {
		game.level_cnt = 0;
		game.level++;
	}

	/* ]B */
	if(!game.block[0].type) DIE();
	if(game.block[1].type) {
		if(!game.block[2].type) DIE();
		game.block_rot = 0; /* ] */
	} else {
		if( game.block[2].type) DIE();
		game.block_rot = 4; /* VO */
	}

	/* ʒuB */
	     if(joy & PAD_LF) p = cols[2];
	else if(joy & PAD_RI) p = cols[1];
	else                  p = cols[0];
	while((col = *p++) >= 0) {
		if(move_test(col, 1, game.block_rot)) break;
	}
	if(col >= 0) {
		result = 1;		/* o\ */
		game.block_col = col;
	} else {
		result = 0;		/* os */
		game.block_col = 2;	/* oʒu */
	}

	/* sʒuB */
	game.block_row = 1;
	game.block_stat = 0; /* o`҂ */
	game.block_pos = fild(0);
	/* o`fBC͎RxɂĕωAZ̎RԂƓƂ܂B
	 * ARxȂꍇłAȂƂBLOCK_PRE_FALL_DELAYۏ؂܂B
	 */
	game.block_delay = fist(fdiv(fld(0.5)/*=block_posZ*/, BLOCK_SPEED));
	if(game.block_delay < BLOCK_PRE_FALL_DELAY) game.block_delay = BLOCK_PRE_FALL_DELAY;

	return result;
}

/****************************************************************************
 *	block_action
 ****************************************************************************/

int
block_action()
{
	/* BR}h... */
	if((joy & PAD_SELECT) && (joy & PAD_A) && (joy & PAD_B)) {
		if(joy & TRG_LF) if(game.level >  0) game.level--;
		if(joy & TRG_RI) if(game.level < 99) game.level++;
		if(joy & TRG_UP) game.star = STAR_FULL;
	}

	/* X^[LZB */
	if(game.block[0].type == CELL_STAR) {
		if((joy & PAD_UP) && (joy & TRG_AB)) {
			game.star_cancel++;
			if(game.star_cancel >= 2) {
				mover_gen(game.block_col + block_col_ofs[game.block_rot][0], game.block_row + block_row_ofs[game.block_rot][0], 5/*10000_*/);
				game.score += 10000; /* X^[LZXRAZ */
				memset(&game.block[0], 0, sizeof(CELL)); /* ̉Ȃ */
				return 1;
			}
		}
	}

	switch(game.block_stat) {
	case 0: /* o`҂ */
		game.block_delay--;
		if((game.block_delay <= 0) || (joy & PAD_DN)/*Jn*/) {
			game.block_stat = 1; /*  */
			goto L_MOVE;
		}
		goto L_MOVE;

	case 1: /*  */
		if(joy & PAD_DN) {
			game.block_pos = fild(0); /*  */
			game.score++; /* ɂXRAZ */
		} else {
			game.block_pos = fsub(game.block_pos, BLOCK_SPEED);
		}
		for(;;) {
			/* ڒnB */
			if(fcom(game.block_pos, <=, fld(0.5))) {
				if(!move_test(game.block_col, game.block_row + 1, game.block_rot)) {
					game.block_stat = 2; /* ڒn`n҂ */
					/* ڒn`ڒfBC͎RxɂĕωAZ̎RԂƓƂ܂B
					 * ARxȂꍇłAȂƂBLOCK_POST_LAND_DELAYۏ؂܂B
					 */
					game.block_delay = fist(fdiv(fld(0.5)/*=block_posZ*/, BLOCK_SPEED));
					if(game.block_delay < BLOCK_POST_LAND_DELAY) game.block_delay = BLOCK_POST_LAND_DELAY;
					game.block_pos = fild(0);
					goto L_MOVE;
				}
			}
			/* B */
			if(ficom(game.block_pos, >, 0)) break;
			game.block_row++;
			game.block_pos = fiadd(game.block_pos, 1);
		}
		goto L_MOVE;

	case 2: /* ڒn`ڒ҂ */
		/* ĊJH */
		if(move_test(game.block_col, game.block_row + 1, game.block_rot)) {
			game.block_stat = 1; /*  */
			goto L_MOVE;
		}
		game.block_delay--;
		if((game.block_delay <= 0) || (joy & PAD_DN)/*ڒ*/) {
			return 1; /* ڒAĂяoɂĎ̉Ă */
		}
		goto L_MOVE;

	default:
		DIE();
	}

L_MOVE:
	/* EړB */
	if((joy & TRG_LF) && (move_test(game.block_col - 1, game.block_row, game.block_rot))) game.block_col--;
	if((joy & TRG_RI) && (move_test(game.block_col + 1, game.block_row, game.block_rot))) game.block_col++;

	/* E]B({͍]ł) */
	if(game.block_rot < 4) {
		if((joy & TRG_B) && (move_test(game.block_col, game.block_row, (game.block_rot + 1) & 3))) game.block_rot = (game.block_rot + 1) & 3;
		if((joy & TRG_A) && (move_test(game.block_col, game.block_row, (game.block_rot - 1) & 3))) game.block_rot = (game.block_rot - 1) & 3;
	}

	/* {[P̂Ȃ΁AŃZgXVB */
	if(game.block[0].type == CELL_BALL && game.block_rot == 4) {
		border_clr();
		border_set(game.block_col + block_col_ofs[game.block_rot][0], game.block_row + block_row_ofs[game.block_rot][0], game.block[0].stat);
	}

	return 0;
}

/****************************************************************************
 *	block_realize
 ****************************************************************************/

int
block_realize()
{
	int i;
	int col;
	int row;
	CELL* cell;

	/* Zg\NAB */
	border_clr();

	for(i = 0; i < 3; i++) {
		if(!game.block[i].type) continue;
		col = game.block_col + block_col_ofs[game.block_rot][i];
		row = game.block_row + block_row_ofs[game.block_rot][i];
		if(col < 0 || col > FIELD_COLS - 1) DIE();
		if(row < 0 || row > FIELD_ROWS - 1) DIE();
		cell = &game.field[row][col];
		memset(cell, 0, sizeof(CELL));
		switch(game.block[i].type) {
		case CELL_COSMO:
			cell->type = CELL_COSMO;
			//cell->stat = 0; /* ʏ */
			//cell->cnt1 = 0;
			cell->cnt2 = COSMO_TIME_TO_SLEEP;
			break;
		case CELL_CONTAINER:
			cell->type = CELL_CONTAINER;
			//cell->stat = 0; /* ʏ */
			break;
		case CELL_BALL:
			cell->type = CELL_BALL;
			cell->stat = game.block[i].stat; /*  */
			break;
		case CELL_STAR:
			if(i != 0) DIE(); /* X^[̓VÔ */
			game.star_row = row;
			game.star_ofs = 0;
			game.star_pos = CELL_H - STAR_SPEED; /* AX^[ڒns̈sɌʂo悤 */
			return 1; /* X^[o */
		default:
			DIE();
		}
	}

	return 0; /* ʏ̎̉ */
}

/****************************************************************************
 *	block_disp / next_disp
 ****************************************************************************/

static void
block_disp_sub(CELL cells[/*3*/], int x0, int y0, int rot)
{
	int i;
	int x;
	int y;
	int sprno;
	CELL* cell;

	/* ̊֐̓VO(rot=4)lĂ܂B
	 * VO(rot=4)](rot=0)Ɠŕ`̂ŁA
	 * VO(rot=4)͉](rot=0)ƂČĂяoĂ!!
	 */
	if(rot & ~3) DIE();

	for(i = 0; i < 3; i++) {
		cell = &cells[i];
		if(!cell->type) continue;

		x = x0 + block_col_ofs[rot][i] * CELL_W;
		y = y0 + block_row_ofs[rot][i] * CELL_H;

		switch(cell->type) {
		case CELL_COSMO:
			sprno = PAT_COSMO_R[(unsigned)now % COUNTOF(PAT_COSMO_R)] + rot * 4;
			break;
		case CELL_CONTAINER:
			sprno = SPR_CONT0 + rot;
			break;
		case CELL_BALL:
			switch(cell->stat) {
			case 0: sprno = SPR_BALL1; break; /* E */
			case 1: sprno = SPR_BALL2; break; /*  */
			default: DIE();
			}
			break;
		case CELL_STAR:
			sprno = SPR_STAR0;
			break;
		default:
			DIE();
		}
		sprite_draw(x, y, sprno, 0);
	}
}

void
block_disp()
{
	int x0;
	int y0;
	int sprno;

	/*** ubN` ***/

	/* ubŇ_W߂܂B */
	x0 = FIELD_X + game.block_col * CELL_W;
	y0 = FIELD_Y + game.block_row * CELL_H;
	if(fcom(game.block_pos, >, fld(0.5))) y0 -= (CELL_H + 1) / 2;

	/* VOłȂ΃ubNg`܂B */
	if(game.block_rot < 4) {
		sprno = SPR_BBDR0 + game.block_rot;
		sprite_draw(x0, y0, sprno, 0);
	}

	/* VO(rot=4)́A](rot=0)ƂČĂяo܂!! */
	block_disp_sub(game.block, x0, y0, game.block_rot & 3);

	/* tB[h̏[}XNB */
	sprite_draw(0, 0, SPR_BGUP, 0);

	/*** NEXT` ***/

	/* ubŇ_W߂܂B */
	x0 = NEXT_X;
	y0 = NEXT_Y + CELL_H;

	/* Jn܂ŁANEXT݂͌̃ubN\ێ܂B */
	block_disp_sub(game.block_stat ? game.next : game.block, x0, y0, 0);
}

void
next_disp()
{
	int x0;
	int y0;

	/*** NEXT` ***/

	/* ubŇ_W߂܂B */
	x0 = NEXT_X;
	y0 = NEXT_Y + CELL_H;

	/* Jn܂ŁANEXT݂͌̃ubN\ێ܂B */
	block_disp_sub(game.block_stat ? game.next : game.block, x0, y0, 0);
}

/****************************************************************************
 *	info_disp
 ****************************************************************************/

void
info_disp()
{
	int n;

	render_printf(&render, SCORE_X, SCORE_Y, 0x82, 3, "%6d", game.score <= 999999 ? game.score : 999999);
	render_printf(&render, COSMO_X, COSMO_Y, 0x82, 3, "%4d", game.cosmo <=   9999 ? game.cosmo :   9999);
	render_printf(&render, LINES_X, LINES_Y, 0x82, 3, "%3d", game.lines <=    999 ? game.lines :    999);
	render_printf(&render, LEVEL_X, LEVEL_Y, 0x82, 3, "%3d", game.level <=    999 ? game.level :    999);

	if(game.star >= STAR_FULL || game.next[0].type == CELL_STAR || game.block[0].type == CELL_STAR) {
		n = STAR_FILL_W;
		render_rectangle_fill(&render, STAR_FILL_X, STAR_FILL_Y, n, STAR_FILL_H, 8);
		sprite_draw(STAR_X, STAR_Y, SPR_STMT1, 0);
	} else {
		n = STAR_FILL_W * game.star / STAR_FULL;
		render_rectangle_fill(&render, STAR_FILL_X, STAR_FILL_Y, n, STAR_FILL_H, 8);
		sprite_draw(STAR_X, STAR_Y, SPR_STMT0, 0);
	}
}

/****************************************************************************
 *	move_test
 ****************************************************************************/

int
move_test(int block_col, int block_row, int block_rot)
{
	int i;
	int col;
	int row;

	for(i = 0; i < 3; i++) {
		if(!game.block[i].type) continue;
		col = block_col + block_col_ofs[block_rot][i];
		row = block_row + block_row_ofs[block_rot][i];
		if(col < 0 || col > FIELD_COLS - 1) return 0;
		if(row < 0 || row > FIELD_ROWS - 1) return 0;
		if(game.field[row][col].type) return 0;
	}

	return 1;
}

/****************************************************************************
 *	field_action
 ****************************************************************************/

void
field_action()
{
	int col;
	int row;
	int sprno;
	CELL* cell;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) continue;

			switch(cell->type) {
			case CELL_COSMO:
				switch(cell->stat) {
				case 0: /* ʏ */
					cell->cnt2--;
					if(cell->cnt2 <= 0) {
						cell->stat = 1; /* Jn */
						cell->cnt1 = 0;
						goto L_NEXT;
					}
					cell->cnt1++;
					if(cell->cnt1 == COUNTOF(PAT_COSMO_0)) {
						cell->cnt1 = 0;
					}
					break;
				case 1: /* Jn */
					cell->cnt1++;
					if(cell->cnt1 == COUNTOF(PAT_COSMO_1)) {
						cell->stat = 2; /*  */
						cell->cnt1 = 0;
						cell->cnt2 = COSMO_TIME_TO_WAKE;
						goto L_NEXT;
					}
					break;
				case 2: /*  */
					cell->cnt2--;
					if(cell->cnt2 <= 0) {
						sprno = PAT_COSMO_2[cell->cnt1];
						if(sprno == SPR_CSM209) {
							if(RND16(game.seed) & 3) {
								cell->stat = 3; /* N#1 */
							} else {
								cell->stat = 4; /* N#2 */
							}
							cell->cnt1 = 0;
							goto L_NEXT;
						}
					}
					cell->cnt1++;
					if(cell->cnt1 == COUNTOF(PAT_COSMO_2)) {
						cell->cnt1 = 0;
					}
					break;
				case 3: /* N#1 */
					cell->cnt1++;
					if(cell->cnt1 == COUNTOF(PAT_COSMO_3)) {
						cell->stat = 1; /* Jn */
						cell->cnt1 = 0;
						goto L_NEXT;
					}
					break;
				case 4: /* N#2 */
					cell->cnt1++;
					if(cell->cnt1 == COUNTOF(PAT_COSMO_4)) {
						cell->stat = 1; /* Jn */
						cell->cnt1 = 0;
						goto L_NEXT;
					}
					break;
				case 5: /* #1 */
					cell->cnt1++;
					if(cell->cnt1 == COUNTOF(PAT_COSMO_5)) {
						cell->stat = 6; /* #2 */
						cell->cnt1 = 0;
						goto L_NEXT;
					}
					break;
				case 6: /* #2 */
					cell->cnt1++;
					if(cell->cnt1 == COUNTOF(PAT_COSMO_6)) {
						cell->stat = 0; /* ʏ */
						cell->cnt1 = 0;
						cell->cnt2 = COSMO_TIME_TO_SLEEP;
						goto L_NEXT;
					}
					break;
				case 7: /* Q[I[o[@ */
					cell->cnt1++;
					if(cell->cnt1 == COUNTOF(PAT_COSMO_7)) {
						cell->cnt1 = 0;
					}
					break;
				default:
					DIE();
				}
				break;

			case CELL_CONTAINER:
				switch(cell->stat) {
				case 0: /* ʏ */
					/** no job **/
					break;
				case 1: /* Œ */
					cell->cnt1++;
					if(cell->cnt1 >= SEC(0.5/**/)) {
						memset(cell, 0, sizeof(CELL));
						goto L_NEXT;
					}
					break;
				case 2: /* Q[I[o[ */
					/** no job **/
					break;
				default:
					DIE();
				}
				break;

			case CELL_BALL:
				switch(cell->stat) {
				case 0: /* E */
					/** no job **/
					break;
				case 1: /*  */
					/** no job **/
					break;
				default:
					DIE();
				}
				break;

			case CELL_STAR:
				DIE(); /* X^[͎̉s */
				break;

			default:
				DIE();
			}
L_NEXT:
		}
	}

	mover_action();
	debris_action();
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

void
field_disp()
{
	int col;
	int row;
	int x;
	int y;
	int sprno;
	CELL* cell;

	/* wi\B */
	memcpy(vbuff, bgbuff, DISP_X * DISP_Y);

	for(row = 1/*ŏi͉ʊO*/; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) continue;

			x = FIELD_X + col * CELL_W;
			y = FIELD_Y + row * CELL_H;

			switch(cell->type) {
			case CELL_COSMO:
				switch(cell->stat) {
				case 0: /* ʏ */
					sprno = PAT_COSMO_0[cell->cnt1];
					sprite_draw(x, y, sprno, 0);
					break;
				case 1: /* Jn */
					sprno = PAT_COSMO_1[cell->cnt1];
					sprite_draw(x, y, sprno, 0);
					break;
				case 2: /*  */
					sprno = PAT_COSMO_2[cell->cnt1];
					sprite_draw(x, y, sprno, 0);
					break;
				case 3: /* N#1 */
					sprno = PAT_COSMO_3[cell->cnt1];
					sprite_draw(x, y, sprno, 0);
					break;
				case 4: /* N#2 */
					sprno = PAT_COSMO_4[cell->cnt1];
					sprite_draw(x, y, sprno, 0);
					break;
				case 5: /* #1 */
					sprno = PAT_COSMO_5[cell->cnt1];
					sprite_draw(x, y, sprno, 0);
					break;
				case 6: /* #2 */
					sprno = PAT_COSMO_6[cell->cnt1];
					sprite_draw(x, y, sprno, 0);
					break;
				case 7: /* Q[I[o[@ */
					sprno = PAT_COSMO_7[cell->cnt1];
					sprite_draw(x, y, sprno, 0);
					break;
				default:
					DIE();
				}
				if(cell->border) { /* Zg */
					if((now & 3) < 2) {
						sprno = SPR_CBDR;
						sprite_draw(x, y, sprno, 0);
					}
				}
				break;

			case CELL_CONTAINER:
				switch(cell->stat) {
				case 0: /* ʏ */
					sprno = SPR_CONT0;
					sprite_draw(x, y, sprno, 0);
					break;
				case 1: /* Œ */
					if(cell->cnt1 & 2) {
						sprno = SPR_CONT0;
						sprite_draw(x, y, sprno, 0);
					}
					break;
				case 2: /* Q[I[o[ */
					sprno = SPR_CONT4;
					sprite_draw(x, y, sprno, 0);
					break;
				default:
					DIE();
				}
				break;

			case CELL_BALL:
				switch(cell->stat) {
				case 0: /* E */
					sprno = SPR_BALL1;
					sprite_draw(x, y, sprno, 0);
					break;
				case 1: /*  */
					sprno = SPR_BALL2;
					sprite_draw(x, y, sprno, 0);
					break;
				default:
					DIE();
				}
				break;

			case CELL_STAR:
				DIE(); /* X^[͎̉s */
				break;

			default:
				DIE();
			}
		}
	}

	next_disp();
	info_disp();

	mover_disp(1); /* RY */
	debris_disp();
	mover_disp(2); /* {[qbg}[NE10000_ */
}

/****************************************************************************
 *	fall_action
 ****************************************************************************/

int
fall_action()
{
	int result = 0;
	//
	int col;
	int row;
	int wake;
	CELL* cell1;
	CELL* cell2;

	for(col = FIELD_COLS - 1; col >= 0; col--) {
		wake = 1;
		for(row = FIELD_ROWS - 1; row >= 1/*v!!*/; row--) {
			cell1 = &game.field[row][col];
			if(cell1->type) continue;
			cell2 = cell1 - FIELD_COLS;
			if(cell2->type) {
				memcpy(cell1, cell2, sizeof(CELL));
				memset(cell2,     0, sizeof(CELL));
				if(wake) {
					if((cell1->type == CELL_COSMO) && (cell1->stat == 2/**/)) {
						cell1->stat = 5; /* N#1 */
						cell1->cnt1 = 0;
					}
				}
				result = 1;
			} else {
				wake = 0;
			}
		}
	}

	return result;
}

/****************************************************************************
 *	line_test
 ****************************************************************************/

int
line_test()
{
	int result = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(cell->type != CELL_CONTAINER) break;
		}
		if(col == FIELD_COLS) {
			for(col = 0; col < FIELD_COLS; col++) {
				cell = &game.field[row][col];
				cell->stat = 1; /* Œ */
				cell->cnt1 = 0;
			}
			game.lines++; /* ŃCJEgAbv */
			game.score += 100 * (1 + game.combo); /* ReiŃXRAZ */
			result = 1;
		}
	}

	return result;
}

/****************************************************************************
 *	line_action
 ****************************************************************************/

int
line_action()
{
	int result = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(cell->type == CELL_CONTAINER) {
				if(cell->stat == 1/*Œ*/) {
					result = 1;
				}
			}
		}
	}

	return result;
}

/****************************************************************************
 *	ball_test
 ****************************************************************************/

int
ball_test()
{
	int col;
	int row;
	CELL* cell;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(cell->type == CELL_BALL) {
				game.ball_col = col;
				game.ball_row = row;
				game.ball_pos = 0;
				game.ball_dir = cell->stat; /* 0:E/1: */
				game.ball_rev = 0;
				memset(cell, 0, sizeof(CELL));
				return 1;
			}
		}
	}

	return 0;
}

/****************************************************************************
 *	ball_action
 ****************************************************************************/

int
ball_action()
{
	int i;
	int x;
	int y;
	int x0;
	int y0;
	CELL* cell;

L_REDO:
	game.ball_pos -= BALL_SPEED;
	for(;;) {
		/* RYŏB */
		if(game.ball_pos < CELL_W / 2) {
			cell = &game.field[game.ball_row][game.ball_col];
			if(cell->type == CELL_COSMO) {
				memset(cell, 0, sizeof(CELL));
				game.cosmo++; /* ŃRYJEgAbv */
				game.score += 10 * (1 + game.combo); /* RYŃXRAZ */
				//if(game.level >= 10) { /* x10ł̓X^[[^[(H) */
					game.star++;  /* X^[[^[JEgAbv */
				//}
				mover_gen(game.ball_col, game.ball_row, RND16(game.seed) & 1 ? 2/*RYE{[(p^[A)*/ : 3/*(p^[B)*/);
				mover_gen(game.ball_col, game.ball_row, 4/*{[qbg}[N*/);
			}
		}
		/* ړB */
		if(game.ball_pos >= 0) break;
		if(game.ball_row < FIELD_ROWS - 1) {
			cell = &game.field[game.ball_row + 1][game.ball_col];
			if(!cell->type || cell->type == CELL_COSMO) {
				game.ball_row++;
				game.ball_pos += CELL_H;
				game.ball_dir |= 2; /* L܂܁A */
				game.ball_rev = 0; /* 񔽓]\ */
				goto L_NEXT;
			}
		}
		game.ball_dir &= ~2; /*  */
		switch(game.ball_dir) {
		case 0: /* E */
			if(game.ball_col < FIELD_COLS - 1) {
				cell = &game.field[game.ball_row][game.ball_col + 1];
				if(!cell->type || cell->type == CELL_COSMO) {
					game.ball_col++;
					game.ball_pos += CELL_W;
					goto L_NEXT;
				}
			}
			game.ball_pos = 0;
			if(!game.ball_rev) { /* ]\H */
				game.ball_dir = 1; /*  */
				game.ball_rev = 1; /* 񔽓]s */
				goto L_REDO;
			}
			return 0; /* {[ */
		case 1: /*  */
			if(game.ball_col > 0) {
				cell = &game.field[game.ball_row][game.ball_col - 1];
				if(!cell->type || cell->type == CELL_COSMO) {
					game.ball_col--;
					game.ball_pos += CELL_W;
					goto L_NEXT;
				}
			}
			game.ball_pos = 0;
			if(!game.ball_rev) { /* ]\H */
				game.ball_dir = 0; /* E */
				game.ball_rev = 1; /* 񔽓]s */
				goto L_REDO;
			}
			return 0; /* {[ */
		default:
			DIE();
		}
L_NEXT:
	}

	x0 = FIELD_X + game.ball_col * CELL_W + 1;
	y0 = FIELD_Y + game.ball_row * CELL_H + 1;
	switch(game.ball_dir) {
	case 0: /* E */
		x0 -= game.ball_pos;
		break;
	case 1: /*  */
		x0 += game.ball_pos;
		break;
	case 2: /* ̂E */
	case 3: /* ̂ */
		y0 -= game.ball_pos;
		break;
	default:
		DIE();
	}
	for(i = 0; i < 8; i++) {
		x = x0 + (RND16(game.seed) & 7); /* x0+1`8 */
		y = y0 + (RND16(game.seed) & 7); /* y0+1`8 */
		debris_gen(x, y);
	}

	return 1;
}

/****************************************************************************
 *	ball_disp
 ****************************************************************************/

void
ball_disp()
{
	int x;
	int y;
	int sprno;

	x = FIELD_X + game.ball_col * CELL_W;
	y = FIELD_Y + game.ball_row * CELL_H;

	switch(game.ball_dir) {
	case 0: /* E */
		x -= game.ball_pos;
		break;
	case 1: /*  */
		x += game.ball_pos;
		break;
	case 2: /* ̂E */
	case 3: /* ̂ */
		y -= game.ball_pos;
		break;
	default:
		DIE();
	}

	sprno = SPR_BALL0;
	sprite_draw(x, y, sprno, 0);
}

/****************************************************************************
 *	star_action
 ****************************************************************************/

int
star_action()
{
	int i;
	int n;
	int x;
	int y;
	int x0;
	int y0;
	int col;
	int row;
	CELL* cell;

	game.star_pos += STAR_SPEED;

	while(game.star_pos >= CELL_H) {
		game.star_pos -= CELL_H;
		game.star_ofs++;
		if(game.star_ofs >= 1 && game.star_ofs <= 7) {
			row = game.star_row + game.star_ofs;
			if(row >= 0 && row <= FIELD_ROWS - 1) {
				for(col = 0; col < FIELD_COLS; col++) {
					cell = &game.field[row][col];
					if(cell->type == CELL_COSMO) {
						memset(cell, 0, sizeof(CELL));
						game.cosmo++; /* ŃRYJEgAbv */
						game.score += 10; /* RYŃXRAZBX^[ł͘A֌WȂ */
						/* X^[ɂRYł̓X^[[^[ɃJEgȂ(H)
						 * {̓JEgĂ悤ȋC܂AȂB
						 */
						mover_gen(col, row, 1/*RYEX^[*/);
					}
				}
			}
		}
	}

	n = FIELD_ROWS - game.star_row;
	if(n > 7) n = 7;
	if(game.star_ofs >= n + 3/*fBC*/) {
		return 0;
	}

	if(game.star_ofs < 7) {
		x0 = FIELD_X;
		y0 = FIELD_Y + (game.star_row + game.star_ofs) * CELL_H + game.star_pos;
		for(i = 0; i < 16; i++) {
			x = x0 + RND16(game.seed) % (FIELD_COLS * CELL_W);
			y = y0 + RND16(game.seed) % (CELL_H / 2);
			debris_gen(x, y);
		}
	}

	return 1;
}

/****************************************************************************
 *	star_disp
 ****************************************************************************/

void
star_disp()
{
	int i;
	int x;
	int y;

	y = game.star_ofs * CELL_H + game.star_pos;
	if(y >= 1 * CELL_H + 0 && y <= 7 * CELL_H + 0) {
		x  = FIELD_X;
		y += FIELD_Y + game.star_row * CELL_H;
		for(i = 0; i < FIELD_COLS; i++) {
			sprite_draw(x, y, SPR_STAR1, 0);
			x += CELL_W;
		}
	}
}

/****************************************************************************
 *	debris_gen
 ****************************************************************************/

void
debris_gen(int x, int y)
{
	int i;
	DEBRIS* debris;

	debris = &game.debris[0];
	for(i = 0; i < MAX_DEBRIS; i++) {
		if(debris->c > 15) {
			debris->c = 0;
			debris->x = x;
			debris->y = fild(y);
			debris->vy = FRND_RANGE(game.seed, fld(0.5), fld(1.0));
			return;
		}
		debris++;
	}
}

/****************************************************************************
 *	debris_action
 ****************************************************************************/

void
debris_action()
{
	int i;
	DEBRIS* debris;

	debris = &game.debris[0];
	for(i = 0; i < MAX_DEBRIS; i++) {
		if(debris->c <= 15) {
			debris->c++;
			debris->y = fadd(debris->y, debris->vy);
		}
		debris++;
	}
}

/****************************************************************************
 *	debris_disp
 ****************************************************************************/

void
debris_disp()
{
	int i;
	DEBRIS* debris;

	debris = &game.debris[0];
	for(i = 0; i < MAX_DEBRIS; i++) {
		if(debris->c <= 15) {
			render_point(&render, debris->x, fist(debris->y), debris->c);
		}
		debris++;
	}
}

/****************************************************************************
 *	mover_gen
 ****************************************************************************/

void
mover_gen(int col, int row, int type)
{
	int i;
	MOVER* mover;

	mover = &game.mover[0];
	for(i = 0; i < MAX_MOVER; i++) {
		if(!mover->type) {
			memset(mover, 0, sizeof mover);
			mover->type = type;
			mover->x = fild(FIELD_X + col * CELL_W);
			mover->y = fild(FIELD_Y + row * CELL_H);
			switch(type) {
			case 1: /* RYEX^[ */
				/** no job **/
				break;
			case 2: /* RYE{[(p^[A) */
			case 3: /* RYE{[(p^[B) */
				mover->vx = FRND_RANGE(game.seed, fild(-1), fild(1));
				mover->vy = FRND_RANGE(game.seed, fild(-4), fild(-5));
				break;
			case 4: /* {[qbg}[N */
				/** no job **/
				break;
			case 5: /* 10000_ */
				mover->vy = fld(-0.5);
				break;
			default:
				DIE();
			}
			return;
		}
		mover++;
	}
}

/****************************************************************************
 *	mover_action
 ****************************************************************************/

void
mover_action()
{
	int i;
	MOVER* mover;

	mover = &game.mover[0];
	for(i = 0; i < MAX_MOVER; i++) {
		switch(mover->type) {
		case 1: /* RYEX^[ */
			mover->cnt++;
			if(mover->cnt >= COUNTOF(PAT_COSMO_S)) {
				memset(mover, 0, sizeof(MOVER));
				goto L_NEXT;
			}
			mover->vy = fadd(mover->vy, fld(-0.1));
			mover->y = fadd(mover->y, mover->vy);
			break;
		case 2: /* RYE{[(p^[A) */
		case 3: /* RYE{[(p^[B) */
			mover->vy = fadd(mover->vy, fld(0.5));
			mover->x = fadd(mover->x, mover->vx);
			mover->y = fadd(mover->y, mover->vy);
			if(ficom(mover->y, >, 0)) {
				if(!mover->cnt) {
					if(ficom(mover->y, >, DISP_Y - CELL_H)) {
						mover->vy = fmul(mover->vy, fld(-0.75));
						mover->cnt = 1;
					}
				} else {
					if(ficom(mover->y, >, DISP_Y)) {
						memset(mover, 0, sizeof(MOVER));
						goto L_NEXT;
					}
				}
			}
			break;
		case 4: /* {[qbg}[N */
			mover->cnt++;
			if(mover->cnt >= 4/**/) {
				memset(mover, 0, sizeof(MOVER));
				goto L_NEXT;
			}
			break;
		case 5: /* 10000_ */
			mover->cnt++;
			if(mover->cnt >= SEC(1)) {
				memset(mover, 0, sizeof(MOVER));
				goto L_NEXT;
			}
			mover->y = fadd(mover->y, mover->vy);
			break;
		}
L_NEXT:
		mover++;
	}
}

/****************************************************************************
 *	mover_disp
 ****************************************************************************/

void
mover_disp(int pass)
{
	int i;
	int sprno;
	MOVER* mover;

	mover = &game.mover[0];
	for(i = 0; i < MAX_MOVER; i++) {
		sprno = -1;
		switch(pass) {
		case 1:
			switch(mover->type) {
			case 1: /* RYEX^[ */
				sprno = PAT_COSMO_S[mover->cnt];
				break;
			case 2: /* RYE{[(p^[A) */
				sprno = SPR_CSM301;
				break;
			case 3: /* RYE{[(p^[B) */
				sprno = SPR_CSM500;
				break;
			}
			break;
		case 2:
			switch(mover->type) {
			case 4: /* {[qbg}[N */
				sprno = mover->cnt < 2/**/ ? SPR_HIT0 : SPR_HIT1;
				break;
			case 5: /* 10000_ */
				sprno = SPR_10000;
				break;
			}
			break;
		default:
			DIE();
		}
		if(sprno != -1) {
			sprite_draw(fist(mover->x), fist(mover->y), sprno, 0);
		}
		mover++;
	}
}

/****************************************************************************
 *	border_clr
 ****************************************************************************/

void
border_clr()
{
	int col;
	int row;
	CELL* cell;

	cell = &game.field[0][0];
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell->border = 0;
			cell++;
		}
	}
}

/****************************************************************************
 *	border_set
 ****************************************************************************/

void
border_set(int col, int row, int dir)
{
	int rev;
	CELL* cell;

	rev = 0;
	for(;;) {
		if(row + 1 <= FIELD_ROWS - 1) {
			cell = &game.field[row + 1][col];
			if(!cell->type || cell->type == CELL_COSMO) {
				row++;
				rev = 0;
				goto L_NEXT;
			}
		}
		switch(dir) {
		case 0: /* E */
			if(col + 1 <= FIELD_COLS - 1) {
				cell = &game.field[row][col + 1];
				if(!cell->type || cell->type == CELL_COSMO) {
					col++;
					goto L_NEXT;
				}
			}
			if(rev) return;
			rev = 1;
			dir = 1; /*  */
			break;
		case 1: /*  */
			if(col - 1 >= 0) {
				cell = &game.field[row][col - 1];
				if(!cell->type || cell->type == CELL_COSMO) {
					col--;
					goto L_NEXT;
				}
			}
			if(rev) return;
			rev = 1;
			dir = 0; /* E */
			break;
		default:
			DIE();
		}
L_NEXT:
		cell = &game.field[row][col];
		if(cell->type == CELL_COSMO) {
			cell->border = 1;
		}
	}
}

/****************************************************************************
 *	ball_interval
 ****************************************************************************/

int
ball_interval(int level)
{
	int result;

	switch(level / 10) {
	case 0:
	case 1:
	case 2:
	case 3:
		result = 3;
		break;
	case 4:
	case 5:
	case 6:
		result = 4;
		break;
	case 7:
	case 8:
	case 9:
		result = 5;
		break;
	default:
		result = 6;
	}

	return result;
}

/****************************************************************************
 *	block_speed
 ****************************************************************************/

fixed
block_speed(int level)
{
	int sec10;
	int frame;
	fixed spd;

	switch(level / 10) {
	case 0:  sec10 = 25; break;
	case 1:  sec10 = 20; break;
	case 2:  sec10 = 15; break;
	case 3:  sec10 =  5; break;
	case 4:  sec10 = 20; break;
	case 5:  sec10 = 15; break;
	case 6:  sec10 = 10; break;
	case 7:  sec10 = 15; break;
	case 8:  sec10 = 10; break;
	case 9:  sec10 =  5; break;
	default: sec10 =  0; break;
	}
	sec10 -= (level % 10) * 2;

	frame = FPS * sec10 / 10;
	if(frame < 1) frame = 1;
	spd = fidiv(fild(1), frame);

	return spd;
}

/****************************************************************************
 *	gameover_action
 ****************************************************************************/

int
gameover_action(int step)
{
	int result = 0;
	int col;
	int row;
	CELL* cell;

	step /= 2;

	if(step < FIELD_ROWS) {
		row = step;
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			switch(cell->type) {
			case CELL_CONTAINER:
				cell->stat = 2; /* Q[I[o[ */
				break;
			}
		}

	} else if(step == FIELD_ROWS) {
		for(row = 0; row < FIELD_ROWS; row++) {
			for(col = 0; col < FIELD_COLS; col++) {
				cell = &game.field[row][col];
				switch(cell->type) {
				case CELL_COSMO:
					cell->stat = 7; /* Q[I[o[ */
					cell->cnt1 = 0;
					break;
				}
			}
		}

	} else {
		result = 1;
	}

	return result;
}

