/*	
 *	clipm65i.h
 *
 *	P/ECE MOS6502 Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2003 Naoyuki Sawa
 *
 *	* Sat Dec 07 12:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_M65I_H__
#define __CLIP_M65I_H__

/*
 *	M6502RAp̃}N`܂B
 *	}NPāȂ̃}NƏՓ˂鋰ꂪ̂ŁA
 *	M6502RA\[Xt@Ĉ݃CN[hĂB
 */

/****************************************************************************
 *
 ****************************************************************************/

/*
 *	M6502\̃oANZX̊ȗ\L
 */
/*===== WX^ =====*/
#define A		(m6502->a)
#define X		(m6502->x)
#define Y		(m6502->y)
#define PC		(m6502->pc)
#define SP		(m6502->sp)
#define PSR		(m6502->psr)
/*=====  =====*/
#define CYCLE		(m6502->cycle)
#define WAIT		(m6502->wait)
/*===== O֐ =====*/
#define READ(a)		    ((m6502->read )(m6502, (unsigned short)(a)))
#define WRITE(a, n)	do { (m6502->write)(m6502, (unsigned short)(a), (unsigned char)(n)); } while(0)

/****************************************************************************
 *
 ****************************************************************************/

/*
 *	16rbgWX^̏/8rbgANZX
 */
#define LO(nn)		(*(((unsigned char*)&(nn)) + 0))
#define HI(nn)		(*(((unsigned char*)&(nn)) + 1))
#define PCL		LO(PC)
#define PCH		HI(PC)

/*
 *	16rbgANZX
 */
#define READ16(a)	(READ(a) | READ((a) + 1) << 8)

/*
 *	PUSH/PULL
 */
#define PUSH(r)		do {       WRITE(0x0100 | SP, (r)); SP--; } while(0)
#define PULL(r)		do { SP++; (r) = READ(0x0100 | SP);       } while(0)

/*
 *	CXgNVtFb`/s
 */
#define FETCH(n)	do {		\
	(n) = READ(PC++);		\
	M6502TRACE("%02x ", (n));	\
} while(0)
#define EXEC()		do {					\
	M6502TRACE("[%s]", &m6502_op_name_table[op->name]);	\
	op->proc(m6502, code, arg);				\
	CYCLE -= op->cycle;					\
} while(0)

#endif /*__CLIP_M65I_H__*/
